質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.40%

  • React.js

    1196questions

    Reactは、アプリケーションのインターフェースを構築するためのオープンソースJavaScriptライブラリです。

  • webpack

    339questions

  • Electron

    246questions

    Electronは、HTML5とNode.jsというWebの技術を用いてデスクトップアプリケーションを作成できるクロスプラットフォームな実行環境です。

  • ビルド

    80questions

    ソースコードを単体で実行可能なソフトウェアへ変換する過程をビルド(build)と呼びます

React.js/JSX・ElectronでWebアプリ Webpack4でのビルドができない

解決済

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 624

Y-A-A

score 3

 前提・実現したいこと

プログラミング歴5ヶ月の初心者です。
本のコードを写経してReact/JSXとElectronを使ったWebアプリ作成の練習をしていますが、webpack4を使ったビルドができません。

2017/08発行の「いまどきのJSプログラマーのためのNode.jsとReactアプリケーション開発テクニック」(クジラ飛行机 著)の第4章「Electronを使ってみよう」のコードを写経しています。

まず、フォルダ'electron_hello'を作成し、electron, react, react-dom, babel-core, babel-preset-es2015, babel-preset-reactをnpmでインストールしました。

構成は
.
|---package.json
|---index.html
|---main.js
|---src
|    |--index.js
|
|---out
|    |--index.js
|
|---webpack.config.js

です。
Electronでpackage.jsonを参照し、main.jsを実行します。outディレクトリにコンパイルされたファイルが出力されるようにしたいです。

 発生している問題・エラーメッセージ

まず本のコードをそのまま写経して npm rub build でビルドをしたら以下のエラーが出ました。

npm ERR! Failed to parse json
npm ERR! Unexpected token } in JSON at position 480 while parsing near '...bpack": "^4.2.0",
npm ERR!   },
npm ERR! }
npm ERR! '
npm ERR! File: C:\Users\clalt\Desktop\electron_hello\package.json
npm ERR! Failed to parse package.json data.
npm ERR! package.json must be actual JSON, not just JavaScript.
npm ERR!
npm ERR! Tell the package author to fix their package.json file. JSON.parse

npm ERR! A complete log of this run can be found in:
npm ERR!     C:\Users\clalt\AppData\Roaming\npm-cache\_logs\2018-03-24T02_12_41_426Z-debug.log

そのときのコードは下記の通りです。
package.jsonのコード

{
"name": "electron_hello",
"version": "1.0.0",
"description": "",
"main": "main.js",
"scripts": {
"start": "electron .",
"build": "webpack"
},
"keywords": [],
"author": "",
"license": "ISC",
"devDependencies": {
"babel-core": "^6.26.0",
"babel-loader": "^7.1.4",
"babel-preset-es2015": "^6.24.1",
"babel-preset-react": "^6.24.1",
"electron": "^1.8.4",
"react": "^16.2.0",
"react-dom": "^16.2.0",
"webpack": "^4.2.0",
},  
}

index.htmlのコード

<!DOCTYPE html>
<html><head>
<meta charset="UTF-8" />
<title>Hello World!</title>
</head><body>
<div id = 'root'></div>
<script src = 'out/index.js'></script>
</body>
</html>

const electron = require('electron')
const path = require('path')
const url = require('url')
const app = electron.app
const BrowserWindow = electron.BrowserWindow
let mainWindow

app.on('ready', createWindow)
app.on('window-all-closed', function () {
if (process.platform !== 'darwin') app.quit()
})
app.on('activate', function () {
if (mainWindow === null) createWindow()
})

main.jsのコード

function createWindow () {
mainWindow = new BrowserWindow({width: 800, height: 600})
mainWindow.loadURL(url.format({
pathname: path.join(__dirname, 'index.html'),
protocol: 'file:',
slashes: true
}))
mainWindow.on('closed', function () {
mainWindow = null
})
}

index.jsのコード

import React, {Component} from 'react'
import ReactDOM from 'react-dom'

export default class App extends Component{
render(){
return (<div>
<h1>Hello</h1>
</div>
)
}
}

ReactDOM.render(
<App />, 
document.getElementById('root')
)

webpack.config.jsのコード

const path = require('path')
const webpack = require('webpack')

const externalPlugins = new webpack.ExternalsPlugin('commonjs', [
'app',
'auto-updater',
'browser-window',
'content-tracing',
'dialog',
'electron',
'global-shortcut',
'ipc',
'menu',
'menu-item',
'power-monitor',
'protocol',
'tray',
'remote',
'web-frame',
'clipboard',
'crash-reporter',
'screen',
'shell'
])

module.export = {
entry:{
index:path.join(dirname, 'src', 'index.js') }, output: { path: path.join(dirname, 'out'),
filename: '[name].js'
},
devtool: 'cheap-module-eval-source-map',
target: 'node',
module: {
rules:[
{
test: /.js$/,
loader: 'babel-loader',
options: {
presets: ['es2015', 'react']
}
}
]
},
plugins: [
externalPlugins
]
}

 試したこと

新しいバージョンのwebpack4をインストールしていること、そして写経したコードはwebpack4に対応したコードではないことは分かりました。
そこで、こちらのページを参考にコードを書き換えました。

設定ファイル不要!webpack 4 でReactをビルドしてみた
https://qiita.com/shisama/items/730e7a2e6a3090a63a38

変更後のwebpack.config.jsのコード

const path = require('path')
const webpack = require('webpack')

module.export = {
mode: 'production',
entry: {
'index': [
path.resolve(dirname, 'src/index.js') ] }, output: { filename: '[name].bundle.js', path: path.resolve(dirname, 'public'),
publicPath: '/',
},
devtool: 'cheap-module-eval-source-map',
target: 'node',
module: {
rules: [
{
test: /\.(js|jsx)$/,
use: 'babel-loader',
},
],
resolve: {
extensions: ['.js', '.jsx'],
}
},
plugins: [
new webpack.DefinePlugin({
'process.env.NODE_ENV': JSON.stringify(process.env.NODE_ENV)
})
],

}

また、webpack-cliが必要ということも分かったので

npm install --save-dev webpack-cli

でインストールをしようとしました。

しかしここで
npm ERR! Failed to parse json
npm ERR! Unexpected token } in JSON at position 480 while parsing near '...bpack": "^4.2.0",
npm ERR!   },
npm ERR! }
npm ERR! '
npm ERR! File: C:\Users\clalt\Desktop\electron_hello\package.json
npm ERR! Failed to parse package.json data.
npm ERR! package.json must be actual JSON, not just JavaScript.
npm ERR!
npm ERR! Tell the package author to fix their package.json file. JSON.parse

npm ERR! A complete log of this run can be found in:
npm ERR!     C:\Users\clalt\AppData\Roaming\npm-cache\_logs\2018-03-24T12_27_15_877Z-debug.log

のエラーが出てしまい webpack-cli がインストールできませんでした。
エラーの2,3行目はpackage.jsonのwebpackのバージョンを表している部分だとは思うのですが、ここからどの部分をどのように修正したらwebpack-cli のインストールをしてビルドが出来るのでしょうか?

ご教示お願い致します。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

+1

package.jsonもJSONファイルですので、配列やオブジェクトの最後にコンマを入れてはいけません

"webpack": "^4.2.0",の最後のコンマを消してください。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/03/24 22:15

    ありがとうございます。
    package.jsonをご指摘の通り "webpack": "^4.2.0"に変えました。

    しかし先ほど同様
    npm ERR! Failed to parse json
    npm ERR! Unexpected token } in JSON at position 484 while parsing near '...k": "^4.2.0"
    のエラーが出てしまいます。

    キャンセル

  • 2018/03/24 22:38

    maisumakunさんが直接指摘しておられる以外にも
     },
    }
    という部分がありこれもNGですね。注意深く「同様の問題がないか」ご自分で確認しましょう!

    キャンセル

  • 2018/03/26 22:18

    その後数か所同様のミスを修正したところ、こちらのエラーが消えました。
    (別のエラーが出たのですが、それはまた別に質問を投稿させていただきます。)
    質問にお答えいただいたお二人、ありがとうございました。

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.40%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る

  • React.js

    1196questions

    Reactは、アプリケーションのインターフェースを構築するためのオープンソースJavaScriptライブラリです。

  • webpack

    339questions

  • Electron

    246questions

    Electronは、HTML5とNode.jsというWebの技術を用いてデスクトップアプリケーションを作成できるクロスプラットフォームな実行環境です。

  • ビルド

    80questions

    ソースコードを単体で実行可能なソフトウェアへ変換する過程をビルド(build)と呼びます